unit zeichenUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TGrafikfenster = class(TForm)
    Baumbutton: TBitBtn;
    Bildflaeche: TImage;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Flockebutton: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    Sierpinskibutton: TBitBtn;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure Vor (Weg: Real);
    procedure Zurueck (Weg: Real);
    procedure Rechts (Winkel: integer);
    procedure Links (Winkel: integer);
    procedure Bildflaecheloeschen;
    {Baum}
    procedure BaumbuttonClick(Sender: TObject);
    procedure Baum (Jahre: Integer; Astlaenge: Real);
    {Kochkurve}
    procedure FlockebuttonClick(Sender: TObject);
    procedure Kochkurve (Stufe: Integer;Groesse:Real);
    procedure Generator (Stufe: Integer; Groesse: Real);
    procedure Initiator (Groesse: Real);
    procedure Schneeflocke (Stufe: Integer; Groesse: Real);
    procedure Dreieck (Laenge: Real);
    {Sierpinski}
    procedure SierpinskibuttonClick(Sender: TObject);
    procedure Sierpinski (Kopien, Seitenlaenge: Real);
    procedure SierpinskiDreieck (Seitenlaenge: Real);
    procedure KopieSierpinski (Kopien, Seitenlaenge: Real);
    {}


   private
    { Private-Deklarationen }
     xp,yp :Real;
     Richtung: integer;
     abgesenkt: boolean;
  public
    { Public-Deklarationen }
  end;

var
  Grafikfenster: TGrafikfenster;

implementation

{$R *.DFM}


procedure TGrafikfenster.Vor (Weg: Real);
var x,y: Real;
begin
    x := Weg*cos(Richtung*PI/180);
    y := Weg*sin(Richtung*PI/180);
    xp := x+xp;
    yp := y+yp;
    if abgesenkt then Bildflaeche.Canvas.lineTo (round (xp), round (yp))
                 else Bildflaeche.Canvas.moveTo (round (xp), round (yp));
end;


procedure TGrafikfenster.Zurueck (Weg: Real);
begin
  vor (-Weg);
end;


procedure TGrafikFenster.Rechts (Winkel: integer);
begin
  Richtung := (Richtung+Winkel) mod 360;
end;


procedure TGrafikFenster.Links (Winkel: integer);
begin
   Richtung := (Richtung-Winkel) mod 360;
end;

procedure TGrafikFenster.Bildflaecheloeschen;
var Flaeche: TRect;
begin
  Flaeche.Top := 0;
  Flaeche.Left := 0;
  Flaeche.Right := Bildflaeche.Width;
  Flaeche.Bottom := Bildflaeche.Height;
  Bildflaeche.Canvas.FillRect(Flaeche);
  Richtung := 270;
  xp := 0.5*Bildflaeche.Width;
  yp := 0.5*Bildflaeche.Height;
  Bildflaeche.Canvas.moveTo (round (xp), round (yp));
end;

{--------------------------------------Baum------------------------------------}

procedure TGrafikfenster.BaumbuttonClick(Sender: TObject);
begin
     Bildflaecheloeschen;
     abgesenkt := false;
     zurueck(0.5*StrToFloat(Edit2.text));
     abgesenkt := True;
     Baum (StrToInt (Edit1.Text),0.5*StrToInt (Edit2.Text));

end;
procedure TGrafikfenster.Baum (Jahre: Integer; Astlaenge: Real);
var Winkel : Integer;
begin
   if Jahre > 0 then begin
     Bildflaeche.Canvas.Pen.Width := Jahre;
     if jahre = StrToInt (Edit1.Text)
        then Bildflaeche.Canvas.Pen.Color := clmaroon
        else Bildflaeche.Canvas.Pen.Color := clgreen;
     Winkel := random (65);
     Vor (Astlaenge);
        (* rechter Ast *)
        Rechts (Winkel);
        Baum ((Jahre - 1), (Astlaenge * 0.7)); (* rekursiver Aufruf *)
        Links (Winkel);
        (*linker Ast *)
        Links (Winkel);
        Baum ((Jahre - 1), (Astlaenge * 0.7)); (* rekursiver Aufruf *)
        Rechts (Winkel);
     Zurueck (Astlaenge);
   end
end;


{-----------------------------Kochkurve----------------------------------------}

procedure TGrafikfenster.FlockebuttonClick(Sender: TObject);
begin
     Richtung := 0;
     Bildflaecheloeschen;
     abgesenkt := false;
     Rechts (90);
     zurueck(0.5*StrToFloat(Edit2.Text));
     abgesenkt := true;
     Kochkurve (StrToInt (Edit1.Text),StrToFloat(Edit2.Text));
end;

procedure TGrafikfenster.Kochkurve (Stufe: Integer;Groesse:Real);
begin
     Bildflaeche.Canvas.Pen.Color := random(32767);
     if Stufe = 0
     then Initiator (Groesse)
     else Generator (Stufe , Groesse);
end;

procedure TGrafikFenster.Generator (Stufe: Integer; Groesse: Real);
begin
     Kochkurve(Stufe-1, Groesse / 3);
     Links (60);
     Kochkurve(Stufe-1, Groesse / 3);
     Rechts (120);
     Kochkurve(Stufe-1, Groesse / 3);
     Links (60);
     Kochkurve(Stufe-1, Groesse / 3);
end;

procedure TGrafikFenster.Initiator(Groesse: Real);
begin
     vor(Groesse);
end;

procedure TGrafikFenster.Schneeflocke (Stufe: Integer; Groesse: Real);
var I: Integer;
begin
     for I := 1 to 6 do
      begin
       Kochkurve (Stufe, Groesse);
       Vor (Groesse);
       Links (60);
      end;
end;

procedure TGrafikFenster.Dreieck (Laenge: Real);
var I: Integer;
begin
     for I := 1 to 3 do
      begin
       Vor (laenge);
       Rechts (120);
      end;
end;


{--------------------------Sierpinski-Dreieck------------------------------------}

procedure TGrafikfenster.SierpinskibuttonClick(Sender: TObject);
begin
     Bildflaecheloeschen;
     abgesenkt := false;
     zurueck(0.5*StrToFloat(Edit2.Text));
     rechts (90);
     zurueck(0.5*StrToFloat(Edit2.Text));
     links(90);
     Sierpinski(StrToInt(Edit1.Text),StrToFloat(Edit2.text));
end;

procedure TGrafikFenster.Sierpinski (Kopien, Seitenlaenge: Real);
begin
     if Kopien = 0
     then SierpinskiDreieck (Seitenlaenge) (*Initiator*)
     else KopieSierpinski (Kopien, Seitenlaenge); (*Generator*)
end;

procedure TGrafikFenster.SierpinskiDreieck (Seitenlaenge: Real);
var I: Integer;
begin
     abgesenkt := true;
     Rechts(30);
     for I := 1 to 3 do
      begin
      Vor (Seitenlaenge);
      Rechts (120);
      end;
     Links (30);
     abgesenkt := false;
end;

procedure TGrafikFenster.KopieSierpinski (Kopien, Seitenlaenge: Real);
begin
     Sierpinski (Kopien - 1, Seitenlaenge / 2);
     Rechts (30);
     Vor (Seitenlaenge / 2);
     Links (30);
     Sierpinski (Kopien - 1, Seitenlaenge / 2);
     Rechts (150);
     Vor (Seitenlaenge / 2);
     Links (150);
     Sierpinski (Kopien - 1, Seitenlaenge / 2);
     Links(90);
     Vor (Seitenlaenge / 2);
     Rechts (90);
end;

{--------------------------------------}



end.
